<?php

namespace Acme\ParqueBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;
use Vich\GeographicalBundle\Annotation as Vich;



/**
 * Acme\ParqueBundle\Entity\Individuos
 *
 * @ORM\Table(name="Individuos")
 * @ORM\Entity(repositoryClass="Acme\ParqueBundle\Entity\IndividuosRepository")
 *
 * @Vich\Geographical(on="update")
 */
class Individuos
{
    /**
     * @var integer $id
     *
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * @var date $plantacion
     *
     * @ORM\Column(name="plantacion", type="date", nullable=false)
     */
    private $plantacion;

    /**
     * @var float $latitude
     *
     * @ORM\Column(name="latitude", type="float", nullable=false)
     */
    private $latitude;

    /**
     * @var float $longitude
     *
     * @ORM\Column(name="longitude", type="float", nullable=false)
     */
    private $longitude;

    /**
     * @var string $foto
     *
     * @ORM\Column(name="foto", type="string", length=255, nullable=true)
     */
    private $foto;

    /**
     * @var Especies
     *
     * @ORM\ManyToOne(targetEntity="Especies")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="especie", referencedColumnName="ID")
     * })
     */
    private $especie;



    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set plantacion
     *
     * @param date $plantacion
     */
    public function setPlantacion($plantacion)
    {
        $this->plantacion = $plantacion;
    }

    /**
     * Get plantacion
     *
     * @return date 
     */
    public function getPlantacion()
    {
        return $this->plantacion;
    }

    /**
     * Set latitude
     *
     * @param float $latitude
     */
    public function setLatitude($latitude)
    {
        $this->latitude = $latitude;
    }

    /**
     * Get latitude
     *
     * @return float 
     */
    public function getLatitude()
    {
        return $this->latitude;
    }

    /**
     * Set longitude
     *
     * @param float $longitude
     */
    public function setLongitude($longitude)
    {
        $this->longitude = $longitude;
    }

    /**
     * Get longitude
     *
     * @return float 
     */
    public function getLongitude()
    {
        return $this->longitude;
    }

    /**
     * Set foto
     *
     * @param string $foto
     */
    public function setFoto($foto)
    {
        $this->foto = $foto;
    }

    /**
     * Get foto
     *
     * @return string 
     */
    public function getFoto()
    {
        return $this->foto;
    }

    /**
     * Set especie
     *
     * @param Acme\ParqueBundle\Entity\Especies $especie
     */
    public function setEspecie(\Acme\ParqueBundle\Entity\Especies $especie)
    {
        $this->especie = $especie;
    }

    /**
     * Get especie
     *
     * @return Acme\ParqueBundle\Entity\Especies 
     */
    public function getEspecie()
    {
        return $this->especie;
    }

    public function __toString(){
    	return $this->getEspecie()->__toString();
    }

    public function getAbsolutePath()
    {
        return null === $this->foto ? null : $this->getUploadRootDir().'/'.$this->foto;
    }

    public function getWebPath()
    {
        return null === $this->foto ? null : $this->getUploadDir().'/'.$this->foto;
    }

    protected function getUploadRootDir()
    {
        // the absolute directory path where uploaded documents should be saved
        return __DIR__.'/../../../../web/'.$this->getUploadDir();
    }

    protected function getUploadDir()
    {
        // get rid of the __DIR__ so it doesn't screw when displaying uploaded doc/image in the view.
        return 'uploads/documents';
    }
}